Title   PCI functions
;
IFDEF USE_OEMHLP
                        include oempci.inc

                        ; ss:ax=para ss:dx=data
p_proc                  call_OEMHLP_IDC_PCI

                        Local @@PACKET          :RequestBlock_10
                        Local @@align_byte      :Byte

                        mov @@PACKET.Length_of_Packet,Size RequestBlock_10
                        mov @@PACKET.Block_Device_Unit_Code,0
                        mov @@PACKET.Command_Code,CMDGenIOCTL
                        and @@PACKET.Request_Packet_Status,0
                        and @@PACKET.Reserved,0
                        and @@PACKET.Queue_Linkage,0
                        mov @@PACKET.RGI_Function_Category,080h
                        mov @@PACKET.RGI_Function_Code,00bh
                        mov @@PACKET.RGI_Parameter_Buffer.offs,ax
                        mov @@PACKET.RGI_Parameter_Buffer.sel ,ss
                        mov @@PACKET.RGI_Data_Buffer.offs,dx
                        mov @@PACKET.RGI_Data_Buffer.sel ,ss
                        mov @@PACKET.RGI_System_File_Num,0
                        mov @@PACKET.RGI_Parameter_Len,0	; not correct, but works
                        mov @@PACKET.RGI_Data_Len,0		; not correct, but works
                        xchg dx,bx

                        mov ss:[bx].Return_Code,086h

                        push ds
                        push es
                        push fs
                        push gs
                        pushad

                          push ss
                          pop es
                          lea bx,@@PACKET
                          push Seg OEMHLP_IDC
                          pop gs
                          mov ds,gs:[OEMHLP_DS]
                          call gs:[OEMHLP_IDC]

                        popad
                        pop gs
                        pop fs
                        pop es
                        pop ds

                        mov ah,ss:[bx].Return_Code

                        xchg bx,dx

                        cmp @@PACKET.Request_Packet_Status,0100h
                        jz @@noerror

IFDEF DEBUG
                        db 0cch
ENDIF
                        mov ax,-1
  @@noerror:
                        cmp ah,0
                        ret
p_endp                  call_OEMHLP_IDC_PCI

;

                        ; does not set edx (' ICP') and edi (protected mode entry point)
p_proc                  Query_PCI_BIOS

                        Local @@PARA:para_packet_80_0b_00
                        Local @@DATA:data_packet_80_0b_00

                        mov @@PARA.Subfunction_Number_00,0

                        push dx

                        lea ax,@@PARA
                        lea dx,@@DATA

                        call call_OEMHLP_IDC_PCI

                        pop dx
                        jnz @@fail

                        mov al,@@DATA.Hardware_Mechanism
                        mov bh,@@DATA.Major_Version
                        mov bl,@@DATA.Minor_Version
                        mov cl,@@DATA.Last_Bus
  @@fail:

                        ret
p_endp                  Query_PCI_BIOS

;

p_proc                  find_pci_class_code

                        Local @@PARA:para_packet_80_0b_02
                        Local @@DATA:data_packet_80_0b_0102

                        mov @@PARA.Subfunction_Number_02,2
                        mov @@PARA.Class_Code,ecx
                        mov ax,si
                        mov @@PARA.Index_02,al

                        push dx

                        lea ax,@@PARA
                        lea dx,@@DATA

                        call call_OEMHLP_IDC_PCI

                        pop dx

                        mov bh,@@DATA.Bus_Number
                        mov bl,@@DATA.DevFunc_Number

                        ret
p_endp                  find_pci_class_code

;

a_proc                  Read_PCI_Byte
                        mov al,1
                        jmp Read_PCI_xxxxx
a_endp                  Read_PCI_Byte

;

a_proc                  Read_PCI_Word
                        mov al,2
                        jmp Read_PCI_xxxxx
a_endp                  Read_PCI_Word

;

a_proc                  Read_PCI_DWord
                        mov al,4
                        jmp Read_PCI_xxxxx
a_endp                  Read_PCI_DWord

;

a_proc                  Write_PCI_Byte
                        mov al,1
                        jmp Write_PCI_xxxxx
a_endp                  Write_PCI_Byte

;

a_proc                  Write_PCI_Word
                        mov al,2
                        jmp Write_PCI_xxxxx
a_endp                  Write_PCI_Word

;

a_proc                  Write_PCI_DWord
                        mov al,4
                        jmp Write_PCI_xxxxx
a_endp                  Write_PCI_DWord

;

p_proc                  Read_PCI_xxxxx

                        Local @@PARA:para_packet_80_0b_03
                        Local @@DATA:data_packet_80_0b_03

                        mov @@PARA.Subfunction_Number_03,3
                        mov @@PARA.Bus_Number_03,bh
                        mov @@PARA.DevFuncNum_03,bl
                        mov @@PARA.Size_03,al
                        mov ax,di
                        mov @@PARA.ConfigurationReg_03,al

                        push dx

                        lea ax,@@PARA
                        lea dx,@@DATA

                        call call_OEMHLP_IDC_PCI

                        pop dx

                        pushf

                        mov cl,Byte Ptr @@DATA.Data_03

                        cmp @@PARA.Size_03,2
                        jb @@exit

                        mov cx,Word Ptr @@DATA.Data_03

                        je @@exit

                        mov ecx,DWord Ptr @@DATA.Data_03
  @@exit:
                        popf

                        ret
p_endp                  Read_PCI_xxxxx

;

p_proc                  Write_PCI_xxxxx

                        Local @@PARA:para_packet_80_0b_04
                        Local @@DATA:data_packet_80_0b_04

                        mov @@PARA.Subfunction_Number_04,4
                        mov @@PARA.Bus_Number_04,bh
                        mov @@PARA.DevFuncNum_04,bl
                        mov @@PARA.Size_04,al
                        mov ax,di
                        mov @@PARA.ConfigurationReg_04,al
                        mov @@PARA.Data_04,ecx

                        push dx

                        lea ax,@@PARA
                        lea dx,@@DATA

                        call call_OEMHLP_IDC_PCI

                        pop dx

                        ret
p_endp                  Write_PCI_xxxxx

;

ELSE                    ; BIOS =================

                        ; AH=0 + ZF=1 : no error
a_proc                  Call_PCI_BIOS
                        push ds
                        push fs
                          push ds
                          pop fs

                          mov ah,0b1h
                          mov ds,BIOS_Selector
IFDEF OS2
                          pushf
                          call fs:[Int15Entrypoint]
ELSE
                          int 01ah
ENDIF

                        pop fs
                        pop ds
                        cmp ah,0
                        ret
a_endp                  Call_PCI_BIOS

;

a_proc                  Query_PCI_BIOS
                        mov al,001h             ; PCI BIOS v2.0c+ - INSTALLATION CHECK
                        jmp Call_PCI_BIOS
a_endp                  Query_PCI_BIOS

;

a_proc                  find_pci_class_code
                        mov al,003h             ; find pci class code
                        jmp Call_PCI_BIOS
a_endp                  find_pci_class_code

;

a_proc                  Read_PCI_Byte
                        mov al,008h           ; read pci cfg byte
                        jmp Call_PCI_BIOS
a_endp                  Read_PCI_Byte

;

a_proc                  Read_PCI_Word
                        mov al,009h           ; read pci cfg word
                        jmp Call_PCI_BIOS
a_endp                  Read_PCI_Word

;

a_proc                  Read_PCI_DWord
                        mov al,00ah           ; read pci cfg dword
                        jmp Call_PCI_BIOS
a_endp                  Read_PCI_DWord

;

a_proc                  Write_PCI_Byte
                        mov al,00bh           ; write pci cfg byte
                        jmp Call_PCI_BIOS
a_endp                  Write_PCI_Byte

;

a_proc                  Write_PCI_Word
                        mov al,00ch           ; write pci cfg word
                        jmp Call_PCI_BIOS
a_endp                  Write_PCI_Word

;

a_proc                  Write_PCI_DWord
                        mov al,00dh           ; write pci cfg dword
                        jmp Call_PCI_BIOS
a_endp                  Write_PCI_DWord

ENDIF                   ; BIOS

;

